VERSION 5.00
Begin VB.Form frmMap 
   BackColor       =   &H00FFFFFF&
   Caption         =   "My Canvas"
   ClientHeight    =   4365
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4815
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4365
   ScaleWidth      =   4815
   Begin VB.PictureBox picMap 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   3135
      Left            =   0
      ScaleHeight     =   205
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   285
      TabIndex        =   0
      Top             =   0
      Width           =   4335
      Begin VB.Timer Timer1 
         Left            =   3480
         Top             =   1560
      End
   End
End
Attribute VB_Name = "frmMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'#################################################################
' This code is part of VB tutorial by
' Kardi Teknomo
' Visit http://people.revoledu.com/kardi/tutorial/VB/index.html
'###################################################################
Public MYCOLOR As Long

Private num As Long
Private X1 As Single
Private Y1 As Single
Private drawFlag As Boolean


Private Sub Form_Resize()
    picMap.Width = Me.Width - 120
    picMap.Height = Me.Height - 400
End Sub


Private Sub picMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim X2 As Single
Dim Y2 As Single

    If Button = vbRightButton Then
        picMap.Cls
    Else
        drawFlag = True
        picMap.DrawWidth = 5
        picMap.PSet (X, Y), MYCOLOR
    End If
End Sub

Private Sub picMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If drawFlag Then
        picMap.Line -(X, Y), MYCOLOR
    End If
End Sub

Private Sub picMap_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    drawFlag = False
End Sub

Private Sub Timer1_Timer()
    Dim PointColor As Long
    Dim LineColor As Long
    Dim maxLine As Integer
    Dim DrawingType As String
    DrawingType = frmController.List1.Text
    maxLine = frmController.ScrlMaxLine.Value
    
    Randomize
    PointColor = Rnd * 16777215   ' 16777215 is maximum color number
    LineColor = Rnd * 16777215
    Call AutoDraw(DrawingType, PointColor, LineColor, maxLine)
End Sub

Sub AutoDraw(DrawingType As String, _
    PointColor As Long, LineColor As Long, _
    maxLine As Integer)
Dim X As Single, Y As Single
Dim X2 As Single, Y2 As Single
Dim count As Integer
Static LastingColor As Long

    X = Rnd * picMap.ScaleWidth
    Y = Rnd * picMap.ScaleHeight
    Select Case DrawingType
    Case "Star"
        If num Mod maxLine = 0 Then
            picMap.Cls
            num = 1
            X1 = X: Y1 = Y
        Else
            num = num + 1
            X2 = X: Y2 = Y
            picMap.DrawWidth = 5
            picMap.PSet (X, Y), PointColor
            picMap.DrawWidth = 1
            picMap.Line (X1, Y1)-(X2, Y2), LineColor
        End If
    Case "Messy"
        If num Mod maxLine = 0 Then
            picMap.Cls
            num = 1
        Else
            num = num + 1
            X2 = X: Y2 = Y
            picMap.DrawWidth = 5
            picMap.PSet (X2, Y2), PointColor
            picMap.DrawWidth = 1
            picMap.Line (X1, Y1)-(X2, Y2), LineColor
            X1 = X2: Y1 = Y2
        End If
    Case "Chain"
        If num Mod maxLine = 0 Then
            picMap.Cls
            num = 1
            X1 = X: Y1 = Y
        Else
            num = num + 1
            count = num Mod 4
            Select Case count
            Case 0:
                X2 = 0.1 * X + X1
                Y2 = 0.1 * Y + Y1
            Case 1:
                X2 = -0.1 * X + X1
                Y2 = -0.1 * Y + Y1
            Case 2:
                X2 = 0.1 * X + X1
                Y2 = -0.1 * Y + Y1
            Case 3:
                X2 = -0.1 * X + X1
                Y2 = 0.1 * Y + Y1
            End Select
            picMap.DrawWidth = 5
            picMap.PSet (X2, Y2), PointColor
            picMap.DrawWidth = 1
            picMap.Line (X1, Y1)-(X2, Y2), LineColor
            X1 = X2: Y1 = Y2
        End If
    Case "Rays"
        If num Mod maxLine = 0 Then
            picMap.Cls
            num = 1
            X1 = X: Y1 = Y
            LastingColor = LineColor
        Else
            num = num + 1
            X2 = X: Y2 = Y
            picMap.DrawWidth = 1
            picMap.Line (X1, Y1)-(X2, Y2), LastingColor - num
        End If
    End Select
End Sub
